/* $Id: extable.c,v 1.1 1999/09/18 16:57:37 gniibe Exp $
 *
 * linux/arch/sh/mm/extable.c
 *  Taken from:
 *   linux/arch/i386/mm/extable.c
 */

#include <linux/config.h>
#include <linux/module.h>
#include <asm/uaccess.h>

//1118    extern const struct exception_table_entry __start___ex_table[];
//1118    extern const struct exception_table_entry __stop___ex_table[];

static inline unsigned long
search_one_table(const struct exception_table_entry *first,
		 const struct exception_table_entry *last,
		 unsigned long value)
{
        while (first <= last) {
		const struct exception_table_entry *mid;
		long diff;

		mid = (last - first) / 2 + first;
		diff = mid->insn - value;
                if (diff == 0)
                        return mid->fixup;
                else if (diff < 0)
                        first = mid+1;
                else
                        last = mid-1;
        }
        return 0;
}

unsigned long
search_exception_table(unsigned long addr)
{
	unsigned long ret;

//1118     #ifndef CONFIG_MODULES
//1118   	/* There is only the kernel to search.  */
//1118   	ret = search_one_table(__start___ex_table, __stop___ex_table-1, addr);
//1118   	if (ret) return ret;
//1118   #else
//1118   	/* The kernel is the last "module" -- no need to treat it special.  */
//1118   	struct module *mp;
//1118   	for (mp = module_list; mp != NULL; mp = mp->next) {
//1118   		if (mp->ex_table_start == NULL)
//1118   			continue;
//1118   		ret = search_one_table(mp->ex_table_start,
//1118   				       mp->ex_table_end - 1, addr);
//1118   		if (ret) return ret;
//1118   	}
//1118   #endif

	return 0;
}
