/*
	Copyright (c) 1992, 1993, 1994, 1995  AXE,Inc.
 */

/*
 *  mem_rt.h
 */

#ifndef  __MEM_RT_H__
#define __MEM_RT_H__

#include "mparam.h"

#ifndef	_FILE_H_
#define	_FILE_H_
#include "file.h"
#include "stdiozrs.h"
#endif
#include "mmu_rt.h"

/***************************************************************************/

#define TBL_PAR_OBJ  32      /** ĤΥꥪ֥Ȥλɥ쥹
				ʪɥ쥹ؤѴơ֥ο */
#define PAGE_PAR_TBL 256     /* ĤΥڡơ֥ˤڡ */

#define FILENAME_LENGTH_MAX 20

#define MEM_NORMAL	0
#define MEM_COW		1	/* copy-on-write memory block */
#define MEM_STACK	2
#define MEM_COMMON	3
#define MEM_WIN		4
#define MEM_FIX		5	/* ɥ쥹Ѵơ֥ѹԲ */
#define MEM_FIX_NOPAGE	6	/* ɥ쥹Ѵơ֥ѹԲ & 
				   ڡơ̵֥ */
#define MEM_FILE	7





struct Mem_info{
    OBJECT_NAME name;
    BYTE4       objType;
    OBJECT_NAME creator;
    int         type;		/* Υ			    */
				/*   MEM_{NORMAL,COW,STACK,FIX,WIN}   */
    BYTE4       vaddr;
    BYTE4       vsize;
    BYTE4       sbrk_vsize;	/* sbrk()Ѥ֤Υ */
    OBJECT_NAME common;		/* ꥦɥޥåפƤ
				   ͭ̾ */
    /* MMU_PAGE    *page_table[TBL_PAR_OBJ]; */
    TLB_ENTRY	*tlb_table;
    char	filename[FILENAME_LENGTH_MAX];
				/* memory mapped file  filename */
    FILE	*fp;		/* memory mapped file  fp */
    struct Mem_info *pre;
    struct Mem_info *next;
};
#define MEM_INFO struct Mem_info


struct Mem_list{
    int count;
#ifdef USE_MMU_TOUCH
    int mmu_touch;
#define MLIST_NOTUPDATE 0
#define MLIST_CHANGE    1
#define MLIST_NOTCHANGE 2
#endif USE_MMU_TOUCH
    int asid;
    MEM_INFO *mlist;
};
#define MEM_LIST struct Mem_list


void MemInit();

MEM_INFO *MemObjCreate();
/*
  MEM_INFO *
  MemObjCreate(name,type,vaddr,size,creator)
  OBJECT_NAME name;
  int type;
  BYTE4 vaddr, size;
  OBJECT_NAME creator;

  Ԥ顢NULL֤.
  ۥɥ쥹ΰ֤ȥMMUδڡ
  魯ɬפ
*/

int MemObjDelete();
/*
  int
  MemObjDelete(mem)
  MEM_INFO *mem;

  ꥪ֥Ȥä
  ץΥꥹȤˤĤʤäƤϾä-1֤
*/


BYTE4 MemObjExpand();
/*
  BYTE4
  MemObjExpand(mem,size)
  MEM_INFO *mem;
  int size;
  ꥪ֥Ȥ֤Υ򿭤Ф˿Ӥ뤫
  ˿Ӥ뤫ϥ֥Ȥ typeǷޤ롣
  ֤ Ф(byte)֤. Ԥ0֤
*/


int MemMapNew();
/*
  int
  MemMapNew(mem, vaddr, size, permission)
  MEM_INFO *mem;
  UBYTE4 vaddr;
  UBYTE4 size;
  int permission;

  ꥪ֥ȤʪͿ롣
  ʪ϶ƤڡȤ
  顼λ-1֤
*/


int MemInsertMemObj();
/*
  MEM_INFO *
  MemInsertMemObj(mem, ins)
  MEM_LIST *mem;
  intMEM_INFO *ins;

  ץΥꥪ֥ȥꥹȤ˿
  ꥪ֥Ȥä롣

  ΰ褬ǤˤĤʤäƤΰ
  ŤʤȤ -1֤
*/

int MemInsertMemObjWin();
/*
  int
  MemInsertMemObjWin(mem, ins)
  MEM_LIST *mem;
  intMEM_INFO *ins;
n*/



int MemExtractMemObj();
/*
  MEM_INFO *
  MemExtractMemObj(mem, ext)
  MEM_LIST *mem;
  intMEM_INFO *ext;

  ץΥꥪ֥ȥꥹȤ
  ĤΥꥪ֥ȤڤΥ

  ڤΥ٤ꥪ֥ȤĤʤ
  -1֤
*/

MEM_INFO *MemObjSearch();
/*
  MEM_INFO *
  MemObjSearch(mlist, address)
  MEM_INFO *mlist;
  unsigned address;
  ֤ ꥪ֥ȤؤΥݥ󥿤֤顼ΤȤNULL

  ɥ쥹(address)ޤǤꥪ֥Ȥmlist椫
  õ
*/


MMU_PAGE MemObjAddressToPage();
/*
  MMU_PAGE
  MemObjAddressToPage(mem,address)
  MEM_INFO *mem;
  unsigned address;

  ɥ쥹(address)ޥåפƤڡΥơ֥֤
*/



void MemMap();
/*
  void
  MemMap(mlst)
  MEM_INFO *mlst;

  ץΥ֤֤إޥåפԤޤ
*/

void MemObjMap();
/*
  void
  MemObjMap(mem)
  MEM_INFO *mem;

  ꥪ֥Ȥ֤˥ޥåפԤޤ
  (ͥνˤȤޤ)
*/


#define PM_RW		0	/* ꡼ɡ饤Ȳ */
#define PM_RONLY	1	/* ꡼ɥ */
#define PM_USER		0	/* 桼⡼ */
#define PM_SUPER	1	/* ѡ⡼ */
char *ProcMemMap();
/*
  char *
  ProcMemMap(mlst, addr)
  MEM_INFO *mlst;
  unsigned addr;  ޥåפΰΥץǤΥɥ쥹

    ץΥɥ쥹֤򥫡ͥΥ˥ޥåפ
    Υݥ󥿤֤(ͥ뤬ץΥ֤Ȥ˻)
    ԤNULL֤ʥ꡼ɡ饤Ȳǽʶ֤ޥåפ
*/


#ifdef PAGESIZE4K
#define page_index_stack(start,size,vaddr) \
	((((start)+(size))/MMU_PAGE_SIZE) - ((vaddr)/MMU_PAGE_SIZE) - 1)
#else PAGESIZE4K
#define page_index_stack(start,size,vaddr) \
	((((start)+(size))/MMU_PAGE_SIZE) - ((vaddr)/MMU_PAGE_SIZE))
#endif PAGESIZE4K
#define page_index(start,vaddr) \
	(((vaddr)/MMU_PAGE_SIZE) - ((start)/MMU_PAGE_SIZE))

extern MEM_INFO *fix_mlist;

#endif  /* __MEM_RT_H__ */
