/*
	Copyright (c) 1992, 1993, 1994, 1995  AXE,Inc.
 */

/*
   mmu_rt.h
*/

#define MMU_PAGE_SIZE      0x1000         /* 4KBYTE PAGE */
#define MMU_PAGE_SIZE2     0x800          /* 2KBYTE PAGE */
#define MMU_PAGE_SIZE1     0x400          /* 1KBYTE PAGE */


#define MMU_TABLE unsigned
#define MMU_PAGE  unsigned
#define MMU_TRANS unsigned

#define PTEL unsigned
             /*	31		          10 9 8 7 6  4  3 2 1  0
			 *	+-------------------+-+-+-+--+--+-+-+--+-+
			 *	|	PPN(1k)	        |0|V|0|PR|SZ|C|D|SH|0|
			 *	+-------------------+-+-+-+--+--+-+-+--+-+
			 *				      SZ=0
			 *
			 *	31		        12 11  8 7 6  4  3 2 1  0
			 *	+-----------------+---+-+-+--+--+-+-+--+-+
			 *	|	PPN(4k)	      |000|V|0|PR|SZ|C|D|SH|0|
			 *	+-----------------+---+-+-+--+--+-+-+--+-+
			 *				      SZ=1
			 */
#define TLB_ENTRY PTEL

#define PR_SR     0        /* super mode  read only    */
#define PR_SRW    1        /* super mode  read / write */
#define PR_UR     2        /* user  mode  read only    */
#define PR_URW    3        /* user  mode  read / write */
#define CACHE_ON  0
#define CACHE_OFF 1
#define NOTCOW	0
#define COW	1
#define PAGE_SIZE_1KB	1
#define PAGE_SIZE_2KB   2
#define PAGE_SIZE_4KB	4


void MmuInit();
void CpuCacheFlush();
void MmuTableCacheFlush();/* ڡơ֥Υ㥷ΥեåԤʤ*/

TLB_ENTRY MmuMakePage();
/*
  TLB_ENTRY
  MmuMakePage(physical_address,psize,permission,cache,cow)
  unsigned physical_address;
  int permission;     ڡΥѡߥåꤹ
                               (PR_SR, PR_SRW, PR_UR, PR_URW)
  int cache;          ڡȤΥ㥷Υ󥪥դꤹ
                               (CACHE_ON, CACHE_OFF)
*/


TLB_ENTRY MmuMakeInvalidPage();
/*
  TLB_ENTRY
  MmuMakeInvalidPage()
*/


unsigned  MmuPageToAddress();
/*
  unsigned
  MmuPageToAddress(page)
  MMU_PAGE page;

  ڡơ֥Ƥ餽λؤƤʪɥ쥹
  Ф֤ޤؤ褬ʤ-1֤ޤ
*/


/* EOF */
